/* Copyright (c) 2011, The Tor Project, Inc. */
/* See LICENSE for licensing information */

#ifndef DOWNLOADWIDGET_H
#define DOWNLOADWIDGET_H

#include <QtGui>

#include "ui/ui_download.h"

class DownloadWidget : public QWidget
{
 Q_OBJECT

 public:
  /** Inline default constructor */
  DownloadWidget(const QString &n, int size, int downloaded, QWidget *parent = 0)
    : QWidget(parent), name(n)
  {
    ui.setupUi(this);

    ui.lblFile->setText(QString("Downloading %1...")
                        .arg(name));
    ui.progressBar->setMaximum(size);
    ui.progressBar->setValue(downloaded);
  }

  /** Destructor */
  ~DownloadWidget() {}
  
  /** Called when the download has finishes */
  void downloadFinished()
  {
    ui.progressBar->setEnabled(false);
    ui.lblFile->setText(QString("Finished downloading %1...")
                        .arg(name));
  }

  /** Updates the displayed value for the progress bar */
  void update(int downloaded)
  {
    ui.progressBar->setValue(downloaded);
  }

 private:
  /** Autogenerated Ui */
  Ui::DownloadWidget ui;
  /** Name for the downloaded file */
  QString name;
};

#endif
